/*-------------------------------------------------------------------
   Name: Xi Dashboard_mq4
   Copyright 2010, Xaphod, http://forexwhiz.appspot.com
   
   Description: Xi Dashboard provides the following info on the chart
        Market Info: 
             Symbol, Bid, Ask and Spread.
        Fractal info with Up/Down color coding:
              PTFH - Pips to fractal high
	           PTFL - Pips to fractal low
	           LFS -  Latest Fractal Swing
	           BSLF - Bars Since Last Fractal	     
	     Pip to price level info with Up/Down color coding:     
	           PTO  - Pips to open	   
	           PTMA1 - Pips to MA1
	           PTMA1 - Pips to MA2	           
	      Moving Average:
	           2 MAs for use with PTMA function above, 2 MA Modes
	           0 = Standard/Fixed MA, 1 = Time-frame variable
	      Last H1/H4 high and low with bar up/down color coding	           
	           S/R lines on chart 	      	      
	      Daily Range:
	           Calculated from parameter market open hour
	           TDR - Todays Range
	           YDR - Yesterdays Range
	           ADR5 - 5 day ADR. Average Range of the last 5 days
	           ADR20 - 20 day ADR. Average Range of the last 20 days	           
	           Alarms and indication for Min and Max range
	      Bar Time Left:
	          Displaying of bar time left adjacent to the current bar
	          
   Change log: 
       2010-03-28. Xaphod, v0.80 
          - First Release 
       2010-03-30. Xaphod, v0.81
          - Fixed: Previous H4 line not being erased.
          - Fixed: PLFS did not change color.
          - Added MA type. Normal and Natural Flow.
          - Made H1/H4 last high/low data and line parameters independent of each other.
          - Added BSLF - Bars Since Last Fractal.
       2010-03-31, Xaphod, v0.82
          - Added dashboard box with optional background color.
          - Improved formatting of data.          
       2010-03-31, Xaphod, v0.83
          -  Release 
          - Fixed pip values off by x100 in 2/3 digit currencies
          - Added dashboard Y-Offset Adjustment parameter
       2010-04-14, Xaphod, v0.84
          - Check for and skip sundays in adr calculation
       2010-05-16, Xaphod, v0.85
          - Added simlation mode
          - Added moving average 2
          - Changed moving average modes. 0=Fixed, 1=Time-frame variable
          - Changed High/Low text color to indicate direction of bar
          - Refactoring
          - Fixed background box resizing on different time-frames
       2010-05-18, Xaphod, v0.86
          - Fixed PTO in SimMode
       2010-05-18, Xaphod, v0.87
          - Added Dashboard X position parameter
          - Added Bar Time Left 
       2010-05-27, Xaphod, v0.88
          - Market Open time setting
          - Adr based on market open
          - ADR Alarms
       2010-06-04, Xaphod, v0.90
          - Rewritten display grid functions: 
            More fexilbility, slightly smaller size, popup descriptions of data
          - ADR color shows when it is within a specified percent of ADR
          - User selectable colors for data labels in the dashboard
       2010-06-10, Xaphod, v0.91
          - Parameter to set the H4 high/low lines from the last H1 candle 
       2010-08-21, Xaphod, v0.94
          - Added Bid up/down colors
          - Translate 'CHF' to 'F' in currency pair display
          - Force dispaly of a 4 digit bid or eqivalent in the market info. 
-----------------------------------------------------------------*/
// Indicator properties
#property copyright "Copyright  2010, Xaphod"
#property link      "http://forexwhiz.appspot.com"
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Salmon
#property indicator_width1 2
#property indicator_color2 Salmon
#property indicator_width2 2
#property indicator_color3 White
#property indicator_width3 2
#property indicator_color4 White
#property indicator_width4 2
#property indicator_color5 Yellow
#property indicator_color6 DeepSkyBlue

#define INDICATOR_NAME "Xi-Dashboard"
#define INDICATOR_VERSION "v0.90"

// GridWriteCell() definitions
// Grid text size and background box sixes
#define GRID_TXT_CHR_SIZE 9   // Text Size
#define GRID_TXT_CHR_WIDTH 7  // Width of text in pixels
#define GRID_TXT_CHR_XOFF 2   // X-Offset used center text in background box
#define GRID_TXT_CHR_YOFF 2   // Y-Offset used center text in background box
#define GRID_BKG_BOX_SIZE 10  // Webding text size that works well with TXT_CHR_SIZE
#define GRID_BKG_BOX_WIDTH 13 // Width of webding box in pixels
// Grid column lengths in chars. Must be float for mathceil calculation.
#define GRID_COL1_LEN 8
#define GRID_COL2_LEN 7
// Grid cell space padding
#define GRID_PAD_OFF  0       // Do not Pad cell content with spaces
#define GRID_PAD_RIGHT 1      // Pad cell content with spaces on the right up to column length
#define GRID_PAD_LEFT 2       // Pad cell content with spaces on the left up to column length

// Dashboard Strings 
// Basic Fractal strings
#define DSS_PTFH  "  PTFH  "
#define DSL_PTFH  "Pips to Fractal High"
#define DSS_PTFL  "  PTFL  "
#define DSL_PTFL  "Pips to Fractal Low"
#define DSS_LFS   "   LFS  "
#define DSL_LFS   "Latest Fractal Swing"
// Extended Fractal strings
#define DSS_BSLF  "  BSLF  "
#define DSL_BSLF  "Bars Since Latest Fractal"
// H1 bar high and low strings
#define DSS_LHH1  "LH(H1)  "
#define DSL_LHH1  "H1 Latest High"
#define DSS_LLH1  "LL(H1)  "
#define DSL_LLH1  "H1 Latest Low"
// H4 bar high and low strings
#define DSS_LHH4  "LH(H4)  "
#define DSL_LHH4  "H4 Latest High"
#define DSS_LLH4  "LL(H4)  "
#define DSL_LLH4  "H4 Latest Low"
// Pips to level strings
#define DSS_PTO   "   PTO  "
#define DSL_PTO   "Pips to Open"
#define DSS_PTMA1 " PTMA1  "
#define DSL_PTMA1 "Pips to MA-1"
#define DSS_PTMA2 " PTMA2  "
#define DSL_PTMA2 "Pips to MA-2"
// ADR Strings
#define DSS_TDR   "   TDR  "
#define DSL_TDR   "Todays Range"
#define DSS_YDR   "   YDR  "
#define DSL_YDR   "Yesterdays Range"
#define DSS_ADR5  "  ADR5  "
#define DSL_ADR5  "ADR for Last 5 Days"
#define DSS_ADR20 " ADR20  "
#define DSL_ADR20 "ADR for Last 20 Days"
// Market info strings
#define DSL_PAIR "Currency Pair"
#define DSL_BID  "Bid Price"
#define DSL_ASK  "Ask Price"
#define DSL_SPREAD  "Spread"

// Time Frames
#define TF_M1  1
#define TF_M5  5
#define TF_M15 15
#define TF_M30 30
#define TF_H1  60
#define TF_H4  240
#define TF_DY  1440
#define TF_WK  10080
#define TF_MN  43200

// ADR definitions
#define ADR_ERR_DATAGAP 1  // Gap in the data
#define ADR_ERR_DATAEND 2  // End of data reached. Not enough data available.
#define ADR_TDR 0          // Index in array
#define ADR_YDR 1
#define ADR_ADR5 2
#define ADR_ADR20 3

// Input parameters
extern string   H1HighLow_BlankLine="";
extern bool     H1HighLow_ShowLines=true; // Show last H1 High/Low lines in the chart
extern bool     H1HighLow_ShowData=true;  // Show last H1 High/Low Data in the dashboard
extern color    H1HighLow_TextColor=IndianRed; // Color of the H1 High/Low text in the Dashboard
extern bool     H4HighLow_ShowLines=true; // Show last H4 High/Low lines in the chart
extern bool     H4HighLow_ShowData=true;  // Show last H4 High/Low Data in the dashboard
extern color    H4HighLow_TextColor=White; // Color of the H4 High/Low text in the Dashboard

extern string   Pips_BlankLine="";
extern bool     Pips_ShowData=true;       // Show Pip Range Data on Dashboard";
extern color    Pips_PTOTextColor=DarkBlue; // Color of the Pips to Price level text in the Dashboard
extern color    Pips_PTMA1TextColor=Yellow; // Color of the Pips to Price level text in the Dashboard
extern color    Pips_PTMA2TextColor=DodgerBlue; // Color of the Pips to Price level text in the Dashboard

extern string   FractalB_BlankLine="";
extern bool     FractalB_ShowData=true;       // Show Fractal High, low last swing on Dashboard";
extern color    FractalB_TextColor=LightBlue; // Color of the Basic Fractal text in the Dashboard

extern string   FractalE_BlankLine="";
extern bool     FractalE_ShowData=true;       // Show Fractal BSLF, ASH, ASL, ANB Dashboard";
extern int      FractalE_NrOfSwings=5;        // Number of swings to average.
extern color    FractalE_TextColor=LightBlue; // Color of the Extended Fractal text in the Dashboard

extern string   Adr_BlankLine="";
extern bool     Adr_ShowData=true;       // Show ADR Data on Dashboard >>";
extern color    Adr_TextColor=DarkBlue; // Color of the ADR text in the Dashboard
extern int      Adr_MarketOpenHour=23;   // Market open hour used to calculate adr info
extern bool     Adr_MinRangeAlert=false; // Enable minimum range exceeded alert
extern int      Adr_MinRangePips=40;     // Threshold for minimum range exceeded alert
extern bool     Adr_MaxRangeAlert=false; // Enable approching maximum range alert
extern double   Adr_MaxRangePercent=80;  // Threshold for approching maximum range alert

extern string   MA1_BlankLine="";
extern string   MA1_TypeInfo="<< 0=Standard/Fixed MA, 1=TF Variable MA  >>";
extern int      MA1_Type=1;        // Type of MA. 0=Fixed MA. Same on all time frames, 1=TF Variable MA;
extern int      MA1_Period=20;     // MA1 Period. Deactivate: MA=0 
extern string   MA1_TFVPeriod="0,12,20,15,12,0,10,12,5"; // MA1 TF Variable Period. "1,5,15,60,240,1440,10080,43200";
extern int      MA1_Shift=0;       // MA1 shift
extern int      MA1_Mode=0;        // MA1 averaging mode: SMA=0, EMA=1, SMMA=2, LWMA=3
extern int      MA1_Price=0;       // Price used for calc: CLOSE=0, OPEN=1, HIGH=2, LOW=3, MEDIAN=4, TYPICAL=5, WEIGHTED=6
extern color    MA1_Color=Yellow;  // Color of the MA1 line

extern string   MA2_BlankLine="";
extern string   MA2_TypeInfo="<< 0=Standard/Fixed MA, 1=TF Variable MA >>";
extern int      MA2_Type=1;           // Type of MA. 0=Fixed MA. Same on all time frames, 1=TF Variable MA;
extern int      MA2_Period=240;       // MA2 Standard Period. Deactivate: MA=0 
extern string   MA2_TFVPeriod="0,180,240,0,240,0,260,240,0"; // MA2 TF Variable Period. "1,5,15,60,240,1440,10080,43200";
extern int      MA2_Shift=0;          // MA2 shift
extern int      MA2_Mode=0;           // MA2 averaging mode: SMA=0, EMA=1, SMMA=2, LWMA=3
extern int      MA2_Price=0;          // Price used for calc: CLOSE=0, OPEN=1, HIGH=2, LOW=3, MEDIAN=4, TYPICAL=5, WEIGHTED=6
extern color    MA2_Color=DodgerBlue; // Color of the MA2 line

extern string   Market_BlankLine="";
extern bool     Market_ShowData=true;         // Show MARKET info in Dashboard 
extern color    Market_SymbolTextColor=Gold;  // Color of the SYMBOL text in the Dashboard
extern bool     Market_Force4Digits=false;    // Display 4 digits for bid and ask even if it is a 5 digit broker
extern color    Market_BidUpTextColor=Lime;   // Color of the BID text in the Dashboard
extern color    Market_BidDnTextColor=Red;    // Color of the BID text in the Dashboard
extern bool     Market_ShowAsk=true;          // Show Ask Data in Dashboard 
extern color    Market_AskTextColor=Maroon;   // Color of the ASK text in the Dashboard
extern bool     Market_ShowSpread=true;       // Show SPREAD Data in Dashboard
extern color    Market_SpreadTextColor=Aqua;  // Color of the SPREAD text in the Dashboard

extern string   BarTime_BlankLine="";
extern bool     BarTime_Enable=true;        // Enable displaying of bar time left adjacent to current bar
extern int      BarTime_Pos=3;              // Position of the bar time relative to the latest bar
extern bool     BarTime_ShowArrow=false;    // Draw an arrow infront of the bar time left "<-15:30"
extern int      BarTime_FontSize=10;        // Font size of bar time left text
extern color    BarTime_TextColor=Aqua;     // Color size of bar time left text
extern int      BarTime_Window=0;           // Window in which to show the bar time left
extern int      BarTime_MaxTimeFrame=60;    // Maximum TF onwhich to show clock: 1,5,15,60,240,1440,10080,43200

extern string   Dashboard_BlankLine="";
extern color    Dashboard_UpTextColor=Blue;   // Text Color for data moving up
extern color    Dashboard_DnTextColor=Maroon; // Text Color for data moving down
//extern color    Dashboard_BkgColor=DarkGray;  // Text Color for dashboard background
extern color    Dashboard_BkgColor=CLR_NONE;  // Text Color for dashboard background
extern color    Dashboard_DividerColor=CLR_NONE; // Color of the line divider text in the Dashboard
extern int      Dashboard_Corner=0;           // Top Left=0, Top Right=1,Bottom left=2, Bottom Right=3
extern int      Dashboard_xPos=1;             // X position offset for dashboard in chart window
extern int      Dashboard_yPos=10;            // Y position offset for dashboard in chart window
extern bool     Dashboard_SimMode=false;      // Simlation mode for VHandsTrade & LHF Trade Simulators

// Global/Module variables
// Indicator buffers
double dH1LHBuffer[];
double dH1LLBuffer[];
double dH4LHBuffer[];
double dH4LLBuffer[];
double dMA1Buffer[];
double dMA2Buffer[];

// MA periods
int iMA1Period=0;    // Current MA1 period
int iMA1TFPeriod[9]={0,0,0,0,0,0,0,0,0};  // MA1 period for all the time frames
int iMA2Period=0;    // Current MA2 period
int iMA2TFPeriod[9]={0,0,0,0,0,0,0,0,0};  // MA2 period for all the time frames
// ADR
int iDataError;      // Used to return data errors in various functions
double dYHigh;       // Yesterdays high price
double dYLow;        // Yesterdays Low price
double dTOpenPrice;  // Todays open price
datetime tTOpenTime; // Todays open time
double dADR[4];      // Calculated ADR values for TDR, YDR, ADR5 and ADR20
// Dashboard
int iGridCurRow=1;   // Current active row in grid
int iGridColPos[3];  // X-position in pixels of the columns
int iGridColLen[3];  // Length in pixels of the columns
int iGridMaxRows;    // Maximum number of rows in the grid
int iGridMktInf[8];  // Market Info positions in pixels


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  // Indicator Settings
  SetIndexStyle(0,DRAW_LINE);
  SetIndexBuffer(0,dH1LHBuffer);
  SetIndexDrawBegin(0, 60/Period());   
  SetIndexLabel(0,"H1 Last High");
  SetIndexStyle(1,DRAW_LINE);
  SetIndexBuffer(1,dH1LLBuffer);
  SetIndexDrawBegin(1, 60/Period());
  SetIndexLabel(1,"H1 Last Low");
  SetIndexStyle(2,DRAW_LINE);
  SetIndexBuffer(2,dH4LHBuffer);
  SetIndexDrawBegin(2, TF_H4/Period()); 
  SetIndexLabel(2,"H4 Last High");  
  SetIndexStyle(3,DRAW_LINE);
  SetIndexBuffer(3,dH4LLBuffer);
  SetIndexDrawBegin(3, TF_H4/Period());   
  SetIndexLabel(3,"H4 Last Low");
  SetIndexStyle(4,DRAW_LINE,EMPTY, EMPTY, MA1_Color);
  SetIndexBuffer(4,dMA1Buffer);  
  SetIndexStyle(5,DRAW_LINE,EMPTY, EMPTY, MA2_Color);
  SetIndexBuffer(5,dMA2Buffer);  
  
  // Set indicator name  
  IndicatorShortName( "[" + INDICATOR_NAME + INDICATOR_VERSION + "]");
  
  // Set lower TF MA Period
  if (MA1_Type==0)
    iMA1Period = MA1_Period;
  else
    iMA1Period = GetMA1TFV(Period());
  SetIndexLabel(4,"MA"+iMA1Period);
  
  // Set Higher TF MA Period
  if (MA2_Type==0)
    iMA2Period = MA2_Period;
  else
    iMA2Period = GetMA2TFV(Period());
  SetIndexLabel(5,"MA"+iMA2Period);
  
  // Simulator settings
  if (Dashboard_SimMode==true) 
    Market_ShowAsk=false; 
  
  // Set Constant variables
  iGridMaxRows=GridHeight();
  GridInit(Dashboard_Corner);
  
  //iTextCorner = Dashboard_Corner;  
  // Bug makes CLR_NONE wrong when edit window is opened an the color is not edited.
//  if (Dashboard_DividerColor<0)
//    Dashboard_DividerColor=-1;
  
  // Exit
  return(0);
}
  
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  int i;
  
  // Clear text objects
  for( i=ObjectsTotal()-1; i>-1; i--)
   if (StringFind(ObjectName(i),INDICATOR_NAME)>=0)  ObjectDelete(ObjectName(i));
  
  GridDeInit(INDICATOR_NAME); 
  // Exit
  return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()  {
  //int iNewBars;
  int iNewTick;
  int iCountedBars; 
  int i;  
  
  // Get unprocessed bars
  iCountedBars=IndicatorCounted();
  if(iCountedBars < 0) return (-1); 
  if(iCountedBars>0) iCountedBars--;
  iNewTick=Bars-iCountedBars;
  
  // Display MA
  if (iMA1Period>0)
    for(i=iNewTick-2; i>=0; i--) 
      dMA1Buffer[i]=iMA(NULL,0,iMA1Period,MA1_Shift,MA1_Mode,MA1_Price,i);
  if (iMA2Period>0)  
    for(i=iNewTick-2; i>=0; i--) 
      dMA2Buffer[i]=iMA(NULL,0,iMA2Period,MA2_Shift,MA2_Mode,MA2_Price,i);
  
  if (BarTime_Enable==true && Dashboard_SimMode==false && BarTime_MaxTimeFrame>=Period()) 
    BarTimeLeft(BarTime_Pos, BarTime_ShowArrow,BarTime_FontSize,BarTime_TextColor,BarTime_Window);       
    
  // Display Market info on Dashboard
  iGridCurRow = 1;  
  if (Market_ShowData==true) {
    DisplayMarketInfo(); 
    GridBlankRow();
    iGridCurRow++; 
  }
  
  // Display basic fractal data on Dashboard
  if (FractalB_ShowData==true) {
    FractalBasicData();     
    GridBlankRow();
    iGridCurRow++;
  }
    
  // Display pip data on Dashboard
  if (Pips_ShowData==true) {
    PipsToOpen();
    PipsToMA();    
    GridBlankRow();
    iGridCurRow++;
  }
  
  // Display extended fractal data on Dashboard
  if (FractalE_ShowData==true) {
    FractalExtendedData();    
    GridBlankRow();
    iGridCurRow++;
  }
  
  // Display H1 and H4 last high/low on Dashboard and draw lines
  SetH1LastHigh();
  SetH4LastHigh();
  if ((H1HighLow_ShowData==true || H4HighLow_ShowData==true) && Period()<TF_H4) {
    GridBlankRow();
    iGridCurRow++; 
  } 
    
  // Display daily range & pip data on Dashboard
  if (Adr_ShowData==true) 
    DailyRange();
  ADRAlarm();
    
  // exit
  return(0);
}
//+------------------------------------------------------------------+


//-----------------------------------------------------------------------------
// function: GetMA1TFV()
// Description: Get MA1 period based on the current time-frame & MA1_TFVPeriod
//-----------------------------------------------------------------------------
int GetMA1TFV(int iPeriod) {
  string sSubStr=MA1_TFVPeriod;
  int i,iTokenEnd;
   
  for (i=0;i<9;i++) {
    iTokenEnd=StringFind(sSubStr,",",0);
    if (iTokenEnd<0) {
      iMA1TFPeriod[i]=StrToInteger(sSubStr);
      break;
    }
    else {       
      iMA1TFPeriod[i]=StrToInteger(StringSubstr(sSubStr,0,iTokenEnd));
      sSubStr=StringSubstr(sSubStr,iTokenEnd+1,StringLen(sSubStr));       
    }  
  }
   
  switch(iPeriod) {
    case TF_M1: return(iMA1TFPeriod[0]);
    case TF_M5: return(iMA1TFPeriod[1]);
    case TF_M15: return(iMA1TFPeriod[2]);
    case TF_M30: return(iMA1TFPeriod[3]);
    case TF_H1: return(iMA1TFPeriod[4]);
    case TF_H4: return(iMA1TFPeriod[5]);
    case TF_DY: return(iMA1TFPeriod[6]);
    case TF_WK: return(iMA1TFPeriod[7]);
    case TF_MN: return(iMA1TFPeriod[8]);
    default: return(0);
  }
  return(0);
}


//-----------------------------------------------------------------------------
// function: GetMA2TFV()
// Description: Get MA2 period based on the current time-frame & MA2_TFVPeriod
//-----------------------------------------------------------------------------
int GetMA2TFV(int iPeriod) {
  string sSubStr=MA2_TFVPeriod;
  int i,iTokenEnd;
   
  for (i=0;i<9;i++) {
    iTokenEnd=StringFind(sSubStr,",",0);
    if (iTokenEnd<0) {
      iMA2TFPeriod[i]=StrToInteger(sSubStr);
      break;
    }
    else {       
      iMA2TFPeriod[i]=StrToInteger(StringSubstr(sSubStr,0,iTokenEnd));
      sSubStr=StringSubstr(sSubStr,iTokenEnd+1,StringLen(sSubStr));       
    }  
  }
  
  switch(iPeriod) {
    case TF_M1: return(iMA2TFPeriod[0]);
    case TF_M5: return(iMA2TFPeriod[1]);
    case TF_M15: return(iMA2TFPeriod[2]);
    case TF_M30: return(iMA2TFPeriod[3]);
    case TF_H1: return(iMA2TFPeriod[4]);
    case TF_H4: return(iMA2TFPeriod[5]);
    case TF_DY: return(iMA2TFPeriod[6]);
    case TF_WK: return(iMA2TFPeriod[7]);
    case TF_MN: return(iMA2TFPeriod[8]);
    default: return(0);
  }
  return(0); 
}


//-----------------------------------------------------------------------------
// function: SetH1LastHigh()
// Description: Calc and display H1 High and Low 
//-----------------------------------------------------------------------------
void SetH1LastHigh() {
  double dHigh;
  double dLow;
  double dBid;
  int iNrOfBars;
  int iPeriod;
  int iShift=-1;
  int i;
  color cTextColor;
  
  // Get and display 14 high & low and draw SR lines
  iPeriod=GetPeriod(Period());  
  if (iPeriod<TF_H1) {  
    // Get index of the end of the last 1H bar
    for (iShift=0; iShift<Bars; iShift++) 
      if (TimeMinute(Time[iShift])== 0) 
        break;
    iShift++;    
    
    // Get nr of bars for the 1H period. There can be bars missing!
    for (i=iShift; i<Bars; i++) 
      if (TimeMinute(Time[i])== 0) 
        break;
    iNrOfBars=i-iShift+1;   
    
    // Find the highest and lowest data for specified nr of bars
    dHigh=High[iHighest(NULL,0,MODE_HIGH,iNrOfBars,iShift)];
    dLow=Low[iLowest(NULL,0,MODE_LOW,iNrOfBars,iShift)];
    
    // Get bid value
    if (Dashboard_SimMode==true) 
      dBid=Close[0]; 
    else 
      dBid=Bid;
  
    // Display on dashboard    
    if (H1HighLow_ShowData==true) {      
      if (Open[iNrOfBars+iShift]>Close[iShift]) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor;
   
      GridWriteCell(DSS_LHH1, iGridCurRow, 1 , GRID_PAD_OFF, DSL_LHH1,  H1HighLow_TextColor, Dashboard_BkgColor);
      GridWriteCell(DoubleToStr(dHigh, Digits), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_LHH1,  cTextColor, Dashboard_BkgColor);
      iGridCurRow++;
      GridWriteCell(DSS_LLH1, iGridCurRow, 1, GRID_PAD_OFF, DSL_LLH1,  H1HighLow_TextColor, Dashboard_BkgColor);
      GridWriteCell(DoubleToStr(dLow, Digits), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_LLH1,  cTextColor, Dashboard_BkgColor);
      iGridCurRow++;
    }
        
    // Draw H/L line
    if (H1HighLow_ShowLines==True)  {
      // Clear old lines
      for(i=iNrOfBars+iShift; i<iNrOfBars+iShift+(1200/iPeriod)+2; i++) {    
        dH1LHBuffer[i]=EMPTY_VALUE;
        dH1LLBuffer[i]=EMPTY_VALUE;    
      } 
      // Draw new lines
      for(i=iShift; i<iNrOfBars+iShift; i++) {    
        dH1LHBuffer[i]=dHigh;
        dH1LLBuffer[i]=dLow;    
      }   
    } // end if 
  } // endif
} // end funcion()


//-----------------------------------------------------------------------------
// function: SetH4LastHigh()
// Description: Calc and display H4 High and Low 
//-----------------------------------------------------------------------------
void SetH4LastHigh() {
  double dHigh;
  double dLow;
  double dBid;
  int iNrOfBars;
  int iPeriod;
  int iShift;
  int i;
  color cTextColor;
  
  // Get and display H4 high & low and draw SR lines
  iPeriod=GetPeriod(Period());  
  if (iPeriod<TF_H4) {
  
    // Get index of the end of the last 4H bar
    for (iShift=0; iShift<Bars; iShift++)
      if (TimeMinute(Time[iShift])== 0 && MathRound(MathMod(TimeHour(Time[iShift]),4))==0) 
        break;
    iShift++;
    
    // Get nr of bars for the 4H period. There can be bars missing!
    for (i=iShift; i<Bars; i++) 
      if (TimeMinute(Time[i])== 0 && MathRound(MathMod(TimeHour(Time[i]),4))==0) 
        break;
    iNrOfBars=i-iShift+1;
   
    // Calc Hih and low for specified nr of bars
    dHigh=High[iHighest(NULL,0,MODE_HIGH,iNrOfBars,iShift)];
    dLow=Low[iLowest(NULL,0,MODE_LOW,iNrOfBars,iShift)];  
    
    // Get bid value
    if (Dashboard_SimMode==true) 
      dBid=Close[0]; 
    else 
      dBid=Bid;
    
    // Display on dashboard
    if (H4HighLow_ShowData==true) {      
      if (Open[iNrOfBars+iShift]>Close[iShift]) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;

      GridWriteCell(DSS_LHH4, iGridCurRow, 1, GRID_PAD_OFF, DSL_LHH4,  H4HighLow_TextColor, Dashboard_BkgColor);
      GridWriteCell(DoubleToStr(dHigh, Digits), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_LHH4,  cTextColor, Dashboard_BkgColor);
      iGridCurRow++;
      GridWriteCell(DSS_LLH4, iGridCurRow, 1, GRID_PAD_OFF, DSL_LLH4,  H4HighLow_TextColor, Dashboard_BkgColor);
      GridWriteCell(DoubleToStr(dLow, Digits), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_LLH4,  cTextColor, Dashboard_BkgColor);
      iGridCurRow++;
    }  
    
    // Draw H/L line 
    if (H4HighLow_ShowLines==True)  {
      // Clear old lines
      for(i=iNrOfBars+iShift; i<iNrOfBars+iShift+(480/iPeriod)+2; i++) {    
        dH4LHBuffer[i]=EMPTY_VALUE;
        dH4LLBuffer[i]=EMPTY_VALUE; 
      } 
      // Draw new lines
      for(i=iShift; i<iNrOfBars+iShift; i++) {    
        dH4LHBuffer[i]=dHigh;
        dH4LLBuffer[i]=dLow;   
      } 
      
    } // endif
  } // endif
} //end funcion()


//-----------------------------------------------------------------------------
// function: FractalBasicData()
// Description: Calc and display:
//        LFS - Last Fractal Swing, 
//        PTFH - Pips To Fractal High, 
//        PTFL - Pips To Fractal Low 
//-----------------------------------------------------------------------------
void FractalBasicData() {
  double dBid;
  int iFractalHigh;
  double dPTFH;
  int iFractalLow;
  double dPTFL;
  double dFractalSwing;
  color cTextColor;
  
  // Get bid value
  if (Dashboard_SimMode==true) 
    dBid=Close[0]; 
  else 
    dBid=Bid;
  
  // Calc Fractals - PLFS - Pips of Last Fractal Swing, PTFH - Pips To Fractal High, PTFL - Pips To Fractal Low 
  iFractalHigh=GetLastFractalIndex( 0, MODE_UPPER);
  iFractalLow=GetLastFractalIndex( 0, MODE_LOWER);    
  
  if (iFractalHigh>=0) 
    dPTFH=PriceToPips( dBid - High[iFractalHigh]);
  if (iFractalLow>=0) 
    dPTFL=PriceToPips( dBid - Low[iFractalLow]);
  dFractalSwing=PriceToPips(High[iFractalHigh]-Low[iFractalLow]); 
  
  // Display Fractal data
  if (dPTFH<=0) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
  
  GridWriteCell(DSS_PTFH, iGridCurRow, 1, GRID_PAD_OFF, DSL_PTFH,  FractalB_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(MathAbs(dPTFH), PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_PTFH,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
    
  if (dPTFL<=0) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
  GridWriteCell(DSS_PTFL, iGridCurRow, 1, GRID_PAD_OFF, DSL_PTFL,  FractalB_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(MathAbs(dPTFL), PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_PTFL,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
  
  if (iFractalHigh>iFractalLow) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
  GridWriteCell(DSS_LFS, iGridCurRow, 1, GRID_PAD_OFF, DSL_LFS,  FractalB_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(MathAbs(dFractalSwing), PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_LFS,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
} // end funcion()


//-----------------------------------------------------------------------------
// function: FractalExtendedData()
// Description: Calc and display:
//        BSLF - Bars Since Last Fractal
//-----------------------------------------------------------------------------
void FractalExtendedData() {
  double dBid;
  int iFractalHigh;
  int iFractalLow;
  int iBSLF;
  color cTextColor;

 // Get bid value
  if (Dashboard_SimMode==true) 
    dBid=Close[0]; 
  else 
    dBid=Bid;
  
  // Calc Fractals - PLFS - Pips of Last Fractal Swing, PTFH - Pips To Fractal High, PTFL - Pips To Fractal Low 
  iFractalHigh=GetLastFractalIndex( 0, MODE_UPPER);
  iFractalLow=GetLastFractalIndex( 0, MODE_LOWER);    
  
  // Calc BSLF - Bars Since Last Fractal
  if (iFractalLow>=iFractalHigh) {
    iBSLF=iFractalHigh;
    if (dBid > High[iFractalHigh]) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor;
  }
  else {
    iBSLF=iFractalLow;
    if (dBid > Low[iFractalLow]) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor;
  }
  
  GridWriteCell(DSS_BSLF, iGridCurRow, 1, GRID_PAD_OFF, DSL_BSLF,  FractalB_TextColor, Dashboard_BkgColor);
  GridWriteCell(iBSLF, iGridCurRow, 2, GRID_PAD_RIGHT, DSL_BSLF,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;  
}


//-----------------------------------------------------------------------------
// function: GetLastFractalIndex()
// Description: Get the index of the latest High or Low Fractal
//-----------------------------------------------------------------------------
int GetLastFractalIndex(int iTimeFrame, int iMode) {
  
  for (int i=0; i<Bars; i++) 
    if (iFractals(NULL, iTimeFrame, iMode, i)!=NULL) return(i); 

  return(-1);
}  // end funcion()


//-----------------------------------------------------------------------------
// function: PipsToOpen()
// Description: Calc and display:
//        PTO - Pips to open
//-----------------------------------------------------------------------------
void PipsToOpen() {
  double dBid;
  double dPTO;
  color cTextColor;
  
  // Get bid value
  if (Dashboard_SimMode==true) 
    dBid=Close[0]; 
  else 
    dBid=Bid;
    
  // Get todays open price & datetime & Calc PTO - Pips to open
  GetMarketOpen(Adr_MarketOpenHour);
  dPTO=PriceToPips(dBid-dTOpenPrice);
  
  // Display PTO  
  if (dPTO<=0) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
  GridWriteCell(DSS_PTO, iGridCurRow, 1, GRID_PAD_OFF, DSL_PTO,  Pips_PTOTextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr( MathAbs(dPTO) ,PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_PTO,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
}


//-----------------------------------------------------------------------------
// function: GetMarketOpen()
// Description: Get the market open time & price
//-----------------------------------------------------------------------------
void GetMarketOpen(int iOpenHour) {
  static datetime tCurHour=0;
  bool bNewHour=false;
  int i;
  int iCloseHour;
  
  // Init vars
  iDataError=0;
  iCloseHour=GetCloseHour(iOpenHour);
  
  // Check for new hour & set new hour flag
  if (Dashboard_SimMode==false) {
    if (tCurHour!=iTime(NULL,TF_H1,0)){
      tCurHour=iTime(NULL,TF_H1,0);   
      bNewHour=true;
    }
  }
  else {
    // Sim mode
    if (TimeHour(Time[0])==iOpenHour && TimeMinute(Time[0])==0) {
      tCurHour=Time[0];   
      bNewHour=true;
    }
  }
    
  if (bNewHour==true) {
    if (Dashboard_SimMode==false) {
      // Move to latest close time
      for (i=0; i<iBars(NULL,TF_H1); i++) {
        if (TimeHour(iTime(NULL,TF_H1,i))==iOpenHour) {  
          // Found open time
          i++;
          break;
        }
        if (TimeHour(iTime(NULL,TF_H1,i))==iCloseHour) { 
          // Found close time
          break;    
        }
        if (i>24) { 
          // Neither open nor close time found within 24 hours
          iDataError=ADR_ERR_DATAGAP;
        break;
        }
      }
      // Get todays open price & datetime
      if (i>0) {
        dTOpenPrice=iOpen(NULL,TF_H1,i-1);
        tTOpenTime=iTime(NULL,TF_H1,i-1);
      }    
    }
    else {
      // Get nr of bars for the period. There can be bars missing!
      for (i=0; i<Bars; i++) 
        if (TimeHour(Time[i])==iOpenHour && TimeMinute(Time[i])==0)
          break;
      dTOpenPrice=Time[i];
      tTOpenTime=Open[i];
    }
  }
}


//-----------------------------------------------------------------------------
// function: PipsToMA()
// Description: Calc and display:
//        PTMA - Pips to MA
//-----------------------------------------------------------------------------
void PipsToMA() {
  double dBid;
  double dPTMA;
  double dCurMA;
  color cTextColor;
  
  // Get bid value
  if (Dashboard_SimMode==true) 
    dBid=Close[0]; 
  else 
    dBid=Bid;
    
  // Calc PTMA - Pips to MA
  if (iMA1Period>0) {
    dCurMA=iMA(NULL,0,iMA1Period,MA1_Shift,MA1_Mode,MA1_Price,0);
    dPTMA=PriceToPips(dBid-dCurMA);
    if (dBid<dCurMA) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
    
    GridWriteCell(DSS_PTMA1, iGridCurRow, 1, GRID_PAD_OFF, DSL_PTMA1,  Pips_PTMA1TextColor, Dashboard_BkgColor);
    GridWriteCell(DoubleToStr(MathAbs(dPTMA) ,PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_PTMA1,  cTextColor, Dashboard_BkgColor);
    iGridCurRow++;
  }
    
  if (iMA2Period>0) {
    dCurMA=iMA(NULL,0,iMA2Period,MA2_Shift,MA2_Mode,MA2_Price,0);
    dPTMA=PriceToPips(dBid-dCurMA);
    if (dBid<dCurMA) cTextColor=Dashboard_DnTextColor; else cTextColor=Dashboard_UpTextColor ;
    GridWriteCell(DSS_PTMA2, iGridCurRow, 1, GRID_PAD_OFF, DSL_PTMA2,  Pips_PTMA2TextColor, Dashboard_BkgColor);
    GridWriteCell(DoubleToStr(MathAbs(dPTMA) ,PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_PTMA2,  cTextColor, Dashboard_BkgColor);
    iGridCurRow++;   
  }  
}


//-----------------------------------------------------------------------------
// function: DailyRange()
// Description: Calc and display the daily range
//-----------------------------------------------------------------------------
void DailyRange() {
  static datetime tCurHour=0;
  double dMaxRangeLimit;
  color cTextColor;
  

  // Calc the ADR
  if (Dashboard_SimMode==false) {
    // Calc the ADR
    dADR[ADR_TDR]=PriceToPips(CalcTDR(Adr_MarketOpenHour));
    if (tCurHour!=iTime(NULL,TF_H1,0)){
      tCurHour=iTime(NULL,TF_H1,0);   
      dADR[ADR_YDR]=PriceToPips(CalcADR(1,Adr_MarketOpenHour));
      dADR[ADR_ADR5]=PriceToPips(CalcADR(5,Adr_MarketOpenHour));
      dADR[ADR_ADR20]=PriceToPips(CalcADR(20,Adr_MarketOpenHour));
    }
  }
  else {
    dADR[ADR_TDR]=PriceToPips(CalcSimTDR(Adr_MarketOpenHour));
    if (tCurHour!=TimeHour(Time[0])) {
      tCurHour=TimeHour(Time[0]);
      dADR[ADR_YDR]=PriceToPips(CalcSimADR(1,Adr_MarketOpenHour));
      dADR[ADR_ADR5]=PriceToPips(CalcSimADR(5,Adr_MarketOpenHour));
      dADR[ADR_ADR20]=PriceToPips(CalcSimADR(20,Adr_MarketOpenHour));
    }
  }
  
  // Display ADR on dashboard
  dMaxRangeLimit=dADR[ADR_YDR]*(Adr_MaxRangePercent/100);
  if (dADR[ADR_TDR]>=Adr_MinRangePips && dADR[ADR_TDR]<dMaxRangeLimit) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor ;
  GridWriteCell(DSS_TDR, iGridCurRow, 1, GRID_PAD_OFF, DSL_TDR,  Adr_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(dADR[ADR_TDR], PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_TDR,  cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
  
  dMaxRangeLimit=dADR[ADR_YDR]*(Adr_MaxRangePercent/100);
  if (dADR[ADR_TDR]<dMaxRangeLimit) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor ;
  GridWriteCell(DSS_YDR, iGridCurRow, 1, GRID_PAD_OFF, DSL_YDR, Adr_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(dADR[ADR_YDR], PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_YDR, cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
  
  dMaxRangeLimit=dADR[ADR_ADR5]*(Adr_MaxRangePercent/100);
  if (dADR[ADR_TDR]<dMaxRangeLimit) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor ;
  GridWriteCell(DSS_ADR5, iGridCurRow, 1, GRID_PAD_OFF, DSL_ADR5, Adr_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(dADR[ADR_ADR5], PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_ADR5, cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
  dMaxRangeLimit=dADR[ADR_ADR20]*(Adr_MaxRangePercent/100);
  if (dADR[ADR_TDR]<dMaxRangeLimit) cTextColor=Dashboard_UpTextColor; else cTextColor=Dashboard_DnTextColor ;
  GridWriteCell(DSS_ADR20, iGridCurRow, 1, GRID_PAD_OFF, DSL_ADR20, Adr_TextColor, Dashboard_BkgColor);
  GridWriteCell(DoubleToStr(dADR[ADR_ADR20], PipPrecision()), iGridCurRow, 2, GRID_PAD_RIGHT, DSL_ADR20, cTextColor, Dashboard_BkgColor);
  iGridCurRow++;
}  // end funcion()


//-----------------------------------------------------------------------------
// function: CalcADR()
// Description: Calc the average daily range for a give number of days
//-----------------------------------------------------------------------------
double CalcADR(int iNrOfDays, int iOpenHour) {
  int i,j;
  int iShiftBeg=0;
  int iNrOfBars=0;
  int iHoursCnt;
  int iCloseHour;
  double dHigh;
  double dLow;
  double tADR=0;
  
  // Init vars
  iDataError=0;
  iCloseHour=GetCloseHour(iOpenHour);
    
  // Move to latest close time
  for (i=0; i<iBars(NULL,TF_H1); i++) {
    if (TimeHour(iTime(NULL,TF_H1,i))==iOpenHour) {  
      // Found open time
      i++;
      break;
    }
    if (TimeHour(iTime(NULL,TF_H1,i))==iCloseHour) { 
      // Found close time
      break;    
    }
    if (i>24) { 
     // Neither open nor close time found within 24 hours
     iDataError=ADR_ERR_DATAGAP;
     break;
    }
  }
  
  // Get todays open price & datetime
  if (i>0) {
    dTOpenPrice=iOpen(NULL,TF_H1,i-1);
    tTOpenTime=iTime(NULL,TF_H1,i-1);
  }
  
  // Sum data for given amount of days
  iShiftBeg=i;  
  for (i=1; i<=iNrOfDays; i++) {    
    iHoursCnt=0;
    // Find next open to close period, starting with close time
    for (j=iShiftBeg; j<iBars(NULL,TF_H1); j++) {      
      if (TimeHour(iTime(NULL,TF_H1,j))==iOpenHour)
        // Found open time
        break;
      if (TimeHour(iTime(NULL,TF_H1,j))==iCloseHour && iHoursCnt>1) {
        // Open time was missing! Close time found
        j=j-1;
        break;    
      } 
      if (iHoursCnt>24) 
        // Neither open nor close time found within 24 hours
        iDataError=ADR_ERR_DATAGAP;
         
      iHoursCnt++;
    }
    // Calc number of bars/hours between opne & close
    iNrOfBars=j-iShiftBeg+1;    

    // Calc High and low for specified nr of bars    
    if (iNrOfBars>12) { // Check that we have at least half a day of bars (no sundays!)      
      dHigh=iHigh(NULL,TF_H1,iHighest(NULL,TF_H1,MODE_HIGH,iNrOfBars,iShiftBeg));
      dLow=iLow(NULL,TF_H1,iLowest(NULL,TF_H1,MODE_LOW,iNrOfBars,iShiftBeg));  
      tADR=tADR+ (dHigh-dLow);
    }
    
    // Get yesterdays high and Low
    if (i==1) {
      dYHigh=dHigh;
      dYLow=dLow;
    }
    
    // Continue with next period, starting with the close
    iShiftBeg=iShiftBeg+iNrOfBars;
  }
  
  // Check if not enough data was available
  if (i<iNrOfDays)
    iDataError=ADR_ERR_DATAEND;
  
  // Calc Average & exit  
  return(tADR/(i-1));
}


//-----------------------------------------------------------------------------
// function: CalcTDR()
// Description: Calc todays daily range. For sim
//-----------------------------------------------------------------------------
double CalcTDR(int iOpenHour) {
  int i;
  int iShift=0;
  int iNrOfBars=0;
  double dHigh;
  double dLow;
  datetime iCloseHour;

  // Init vars
  iDataError=0;
  iCloseHour=GetCloseHour(iOpenHour);

  // Move to latest close time
  for (i=0; i<iBars(NULL,TF_H1); i++) {
    if (TimeHour(iTime(NULL,TF_H1,i))==iOpenHour )
      break;
      
    if (TimeHour(iTime(NULL,TF_H1,i))==iCloseHour && i>0) { 
      // Found close time
      i++;
      break;    
    }
    
    if (i>24) { 
     // Neither open nor close time found within 24 hours
     iDataError=ADR_ERR_DATAGAP;
     break;
    }
  }
         
  // Calc High and low for specified nr of bars
  dHigh=iHigh(NULL,TF_H1,iHighest(NULL,TF_H1,MODE_HIGH,i+1,0));
  dLow=iLow(NULL,TF_H1,iLowest(NULL,TF_H1,MODE_LOW,i+1,0));  
    
  return(dHigh-dLow);
}


//-----------------------------------------------------------------------------
// function: ADRAlarm()
// Description: Calc todays daily range. For sim
//-----------------------------------------------------------------------------
void ADRAlarm() {
  static datetime tToday=0;
  static bool bMinAlarm=false;
  static bool bMaxAlarm=false;

  // Check if a new day has started and reset vars
  if (tTOpenTime!=tToday) {
    tToday=tTOpenTime;
    bMinAlarm=false;
    bMaxAlarm=false;    
  }
  
  // Minumim range exceeded alert
  if (bMinAlarm==false) {
    if (dADR[ADR_TDR]>=Adr_MinRangePips) {
      bMinAlarm=true;
      if (Adr_MinRangeAlert==true)
        Alert(Symbol()," - Minimum Range Exceeded. ",INDICATOR_NAME);
    }
  }
  
  // Maximun range within reach alert
  if (bMaxAlarm==false) {      
    if (dADR[ADR_TDR]*(Adr_MaxRangePercent/100)>=dADR[ADR_YDR] ) {
      bMaxAlarm=true;
      if (Adr_MaxRangeAlert==true)
        Alert(Symbol()," - Maximum Range Warning. ",INDICATOR_NAME);
    }
  }  
}


//-----------------------------------------------------------------------------
// function: GetCloseHour()
// Description: Return the market close hour
//-----------------------------------------------------------------------------
int GetCloseHour(int iOpenHour) {
  if (iOpenHour==0) 
    return(23);
  else
    return(iOpenHour-1);
}


//-----------------------------------------------------------------------------
// function: CalcSimTDR()
// Description: Calc todays daily range. For sim
//-----------------------------------------------------------------------------
double CalcSimTDR(int iOpenHour) {
  int i;
  int iShift=0;
  int iNrOfBars=0;
  double dHigh;
  double dLow;

  // Get nr of bars for the period. There can be bars missing!
  for (i=0; i<Bars; i++) 
    if (TimeHour(Time[i])==iOpenHour && TimeMinute(Time[i])==0)
      break;
       
  // Calc Hih and low for specified nr of bars
  dHigh=High[iHighest(NULL,0,MODE_HIGH,i+1,0)];
  dLow=Low[iLowest(NULL,0,MODE_LOW,i+1,0)];  
    
  return(dHigh-dLow);
}


//-----------------------------------------------------------------------------
// function: CalcSimTDR()
// Description: Calc todays daily range. For sim
//-----------------------------------------------------------------------------
double CalcSimADR(int iNrOfDays,int iOpenHour) {
  int i,j;
  int iShiftBeg=0;
  int iShiftEnd=0;
  int iNrOfBars=0;
  double dHigh;
  double dLow;
  double tADR=0;

  // Get nr of bars form the last 00:000 hours
  for (i=0; i<Bars; i++) 
    if (TimeHour(Time[i])==iOpenHour && TimeMinute(Time[i])==0)
      break;
  
  // start from end of day, 23:59
  iShiftBeg=i+1;
  for (i=1; i<=iNrOfDays; i++) {    
    for (j=iShiftBeg; j<Bars; j++) {
      if (TimeHour(Time[j])==iOpenHour && TimeMinute(Time[j])==0)
        break;
    }
    iNrOfBars=j-iShiftBeg+1;    
    // Calc Hih and low for specified nr of bars    
    if (iNrOfBars>(12*(60.0/Period()))) { // Check that we have at least half a day of bars (no sundays!)
      dHigh=High[iHighest(NULL,0,MODE_HIGH,iNrOfBars,iShiftBeg)];
      dLow=Low[iLowest(NULL,0,MODE_LOW,iNrOfBars,iShiftBeg)];  
      tADR=tADR+ (dHigh-dLow);
    }
    iShiftBeg=iShiftBeg+iNrOfBars;
  }
  return(tADR/(i-1));
}


//-----------------------------------------------------------------------------
// function: DisplayMarketInfo()
// Description: Calc the average daily range over a number of days
//-----------------------------------------------------------------------------
void DisplayMarketInfo() {
  int iDigits;
  double dCurBid;
  static double dPrevBid;
  static color cBidColor;
  string sCurValue;
  
  // Get bid value
  if (Dashboard_SimMode==true) 
    dCurBid=Close[0]; 
  else 
    dCurBid=Bid;
    
  if (dCurBid>dPrevBid) cBidColor=Market_BidUpTextColor;
  else if (dCurBid<dPrevBid) cBidColor=Market_BidDnTextColor;
  dPrevBid=dCurBid;
   
  GridWriteCell("        ", iGridCurRow, 1, GRID_PAD_OFF, DSL_PAIR,  CLR_NONE, Dashboard_BkgColor);
  GridWriteCell("       ", iGridCurRow, 2, GRID_PAD_RIGHT, DSL_BID,  CLR_NONE, Dashboard_BkgColor);
  iGridCurRow++;
  GridWriteCell("        ", iGridCurRow, 1, GRID_PAD_OFF, DSL_PAIR,  CLR_NONE, Dashboard_BkgColor);
  GridWriteCell("       ", iGridCurRow, 2, GRID_PAD_RIGHT, DSL_ASK,  CLR_NONE, Dashboard_BkgColor);
  iGridCurRow++;

  // Instrument 
  WriteText(GetShortSymbol(Symbol()), iGridMktInf[0], iGridMktInf[1], DSL_PAIR,  22, Market_SymbolTextColor);
    
  // Bid Price
  if (Market_Force4Digits) iDigits=Force4Digits();
  else iDigits=Digits;
  
  sCurValue=DoubleToStr( dCurBid, iDigits);
  sCurValue=sCurValue+PadStr(7-StringLen(sCurValue));
  WriteText(sCurValue, iGridMktInf[2], iGridMktInf[3], DSL_BID,  14, cBidColor);

  // Ask Price    
  if (Market_ShowAsk==True) {
    sCurValue=DoubleToStr( Ask, iDigits);
    sCurValue=sCurValue+PadStr(10-StringLen(sCurValue));
    WriteText(sCurValue, iGridMktInf[4], iGridMktInf[5], DSL_ASK,  9, Market_AskTextColor);
  }
  
  // Spread
  if (Market_ShowSpread==True) {
    sCurValue="Spread "+ DoubleToStr( PriceToPips(Ask-Bid) , PipPrecision());
    sCurValue=sCurValue+PadStr(10-StringLen(sCurValue));

    if (Market_ShowAsk==False) {
      WriteText(sCurValue, iGridMktInf[4], iGridMktInf[5], DSL_SPREAD,  9, Market_SpreadTextColor);
    }
    else {
      GridWriteCell("        ", iGridCurRow, 1, GRID_PAD_OFF, DSL_PAIR,  CLR_NONE, Dashboard_BkgColor);
      GridWriteCell("       ", iGridCurRow, 2, GRID_PAD_RIGHT, DSL_SPREAD,  CLR_NONE, Dashboard_BkgColor);
      iGridCurRow++;
      WriteText(sCurValue, iGridMktInf[6], iGridMktInf[7], DSL_SPREAD,  9, Market_SpreadTextColor);
    }
  }    
}  // end funcion()


//-----------------------------------------------------------------------------
// function: BarTimeLeft()
// Description: Displays the bar time left next to the current bar.
//-----------------------------------------------------------------------------
int BarTimeLeft(int iBarTime_Pos=3, bool bShowArrow=False, int iFontSize=8, color cTextColor=Black ,color iWindow=0) {
  datetime tTimeLeft,tTextPos;
  double dPrice;
  string sBarTimeLeft;
  string sObjTextName=INDICATOR_NAME+"_BarTime_Text";
  string sArrow=CharToStr(60)+CharToStr(150);
  
  // Calc time left and display position
  tTimeLeft=Time[0]+Period()*60-TimeCurrent();
  tTextPos=Time[0]+Period()*60*iBarTime_Pos;
  if (iWindow==0)
    dPrice=Bid;
  else
    dPrice=iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0)+6;
  
  // Show hours if period > 60 min 
  if (Period()>60) {
    sBarTimeLeft=TimeToStr(tTimeLeft,TIME_SECONDS );
    }
  else {
    sBarTimeLeft=StringSubstr(TimeToStr(tTimeLeft,TIME_SECONDS),3);
  }  

  // Exit if time is not available  
  if (sBarTimeLeft=="alid time")
    return(0);
  
  // Add Arrow infront of time
  if (bShowArrow==true) {
   sBarTimeLeft=sArrow+sBarTimeLeft;
  }  
  
  // Display time left    
//  if (iWindow>=0 && iWindow<WindowsTotal()) { // has to be checked
    if (ObjectFind(sObjTextName)>=0 ) ObjectDelete(sObjTextName);      
    ObjectCreate(sObjTextName, OBJ_TEXT, iWindow, tTextPos, dPrice);
    ObjectSet(sObjTextName, OBJPROP_BACK, false);
    ObjectSetText(sObjTextName, sBarTimeLeft , iFontSize, "Arial", cTextColor);
//  }
  
  return(0);
}


//-----------------------------------------------------------------------------
// function: GetPeriod()
// Description: Get the current period. Translate vHandsTrade simulator periods
//              to standard  periods.
//-----------------------------------------------------------------------------
int GetPeriod(int iCurPeriod)  {
  int iResult;
  
  if (iCurPeriod==0) iCurPeriod=Period();
  
  switch (iCurPeriod) {
    case 2: iResult=TF_M1; break;   
    case 6: iResult=TF_M5; break;   
    case 16: iResult=TF_M15; break;
    case 31: iResult=TF_M30; break;
    case 61: iResult=TF_H1; break;
    case 241: iResult=TF_H4; break;
    case 1441: iResult=TF_DY; break;
    case 10081: iResult=TF_WK; break;
    case 43201: iResult=TF_MN; break;
    default: iResult=iCurPeriod; 
  }
  return(iResult);
} // end funcion()


//-----------------------------------------------------------------------------
// function: PriceToPips()
// Description: Convert a proce difference to pips.
//-----------------------------------------------------------------------------
int Force4Digits() {

  if (Digits==2 || Digits==3) 
    return(2); 
  else if (Digits==4 || Digits==5) 
    return(4); 
  else
    return(Digits);            
} // end funcion()


//-----------------------------------------------------------------------------
// function: PriceToPips()
// Description: Convert a proce difference to pips.
//-----------------------------------------------------------------------------
double PriceToPips(double dPrice) {

  if (Digits==2 || Digits==3) 
    return(dPrice/0.01); 
  else if (Digits==4 || Digits==5) 
    return(dPrice/0.0001); 
  else
    return(dPrice);            
} // end funcion()


//-----------------------------------------------------------------------------
// function: PipPrecision()
// Description: Digits of the pips
//-----------------------------------------------------------------------------
double PipPrecision() {

 if (Digits==3 || Digits==5) 
    return(1); 
  else if (Digits==2 || Digits==4) 
    return(0); 
  else
    return(0);            
} // end funcion()
  

//-----------------------------------------------------------------------------
// function: GetShortSymbol()
// Description: Shorten a symbol name. Tex. EURUSD = EU, GBPUSD = GU
//-----------------------------------------------------------------------------
string GetShortSymbol(string sSymbol) {
  string sResult="";
  string sFirst=StringSubstr(sSymbol,0,3);
  string sSecond=StringSubstr(sSymbol,3,3);
  
  if (sFirst=="CHF") 
    sResult="F"+StringSubstr( sSymbol, 3, 1);
  else if (sSecond=="CHF")
    sResult=StringSubstr( sSymbol, 0, 1)+"F";
  else if (sSymbol=="XAU")
    sResult="AU";
  else if (sSymbol=="XAG")
    sResult="AG";
  else if (StringLen(sSymbol)>5)
    sResult=StringSubstr( sSymbol, 0, 1)+ StringSubstr( sSymbol, 3, 1);
  else
    sResult=sSymbol;
  
  return(sResult);
} // end funcion()


//-----------------------------------------------------------------------------
// function: PadStr()
// Description: Create a blank string N chars long
//-----------------------------------------------------------------------------
string PadStr(int iSize) {
  string sReturn ="";
  
  for (int i=0; i<iSize; i++)
    sReturn=sReturn+" ";
  return(sReturn);
} // end funcion()


//-----------------------------------------------------------------------------
// function: GridWriteCell()
// Description: Write text in a display grid
// Globals: Dashboard_Corner, Dashboard_xPos, Dashboard_yPos, iGridColPos[]
//          iGridMaxRows, 
//-----------------------------------------------------------------------------
void GridWriteCell(string sText,int iRow, int iCol, int iPadText, string sObjId, color cTxtColor, color cBkgColor) {
  int iBkgBoxCnt;
  int iStrLen;
  int iY,iX;
  string sBkgObjId;
  string sBkgCell;
  double dMaxStrLen;
  int iMaxStrLen;
    
  // Set object name
  sBkgObjId=INDICATOR_NAME+"("+iRow+"."+iCol+"): "+sObjId;
  sObjId=INDICATOR_NAME+"["+iRow+"."+iCol+"]: "+sObjId;  
  
  // calc x and y coordinates  
  iY=CalcYPos(iRow);
  iX=iGridColPos[iCol-1];
  
  // Pad string
  iMaxStrLen=iGridColLen[iCol-1];
  if (iPadText==GRID_PAD_RIGHT) {
    iStrLen=StringLen(sText);
    if (iStrLen<iMaxStrLen) sText=sText+PadStr(iMaxStrLen-iStrLen);
  }
  else if (iPadText==GRID_PAD_LEFT) {
    iStrLen=StringLen(sText);
    if (iStrLen<iMaxStrLen) sText=PadStr(iMaxStrLen-iStrLen)+sText;
  }

  // Print Text
  if (ObjectFind(sObjId)<1 ) {
    ObjectCreate(sObjId, OBJ_LABEL, 0, 0, 0, 0, 0);
    ObjectSet(sObjId, OBJPROP_CORNER, Dashboard_Corner);
    ObjectSet(sObjId, OBJPROP_XDISTANCE, iX+GRID_TXT_CHR_XOFF);
    ObjectSet(sObjId, OBJPROP_YDISTANCE, iY+GRID_TXT_CHR_YOFF);
    ObjectSet(sObjId, OBJPROP_BACK, false);
  }
  ObjectSetText(sObjId, sText, GRID_TXT_CHR_SIZE, "Courier New", cTxtColor);
  
  if (cBkgColor!=CLR_NONE) {  
    dMaxStrLen=iMaxStrLen;
    iBkgBoxCnt=MathCeil(dMaxStrLen*GRID_TXT_CHR_WIDTH/GRID_BKG_BOX_WIDTH); // Nr of cell boxes used to draw cell
    for (int i=0;i<iBkgBoxCnt;i++) 
      sBkgCell=sBkgCell+"g";
    
    if (ObjectFind(sBkgObjId)<1 ) {
      ObjectCreate(sBkgObjId, OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSet(sBkgObjId, OBJPROP_CORNER, Dashboard_Corner);
      ObjectSet(sBkgObjId, OBJPROP_XDISTANCE, iX);
      ObjectSet(sBkgObjId, OBJPROP_YDISTANCE, iY);
      ObjectSet(sBkgObjId, OBJPROP_BACK, false);
      ObjectSetText(sBkgObjId, sBkgCell, GRID_BKG_BOX_SIZE, "Webdings", cBkgColor);
    }
  }
}


//-----------------------------------------------------------------------------
// function: WriteText()
// Description: Write text to xy position in window
//-----------------------------------------------------------------------------
void WriteText(string sText, int iX, int iY, string sObjId, int iTextsize, color cTxtColor) {

  sObjId=INDICATOR_NAME+"["+iX+"."+iY+"]- "+sObjId;

  // Print Text
  if (ObjectFind(sObjId)>0 ) ObjectDelete(sObjId); 
  ObjectCreate(sObjId, OBJ_LABEL, 0, 0, 0, 0, 0);
  ObjectSet(sObjId, OBJPROP_CORNER, Dashboard_Corner);
  ObjectSet(sObjId, OBJPROP_XDISTANCE, iX);
  ObjectSet(sObjId, OBJPROP_YDISTANCE, iY);
  ObjectSet(sObjId, OBJPROP_BACK, false);
  ObjectSetText(sObjId, sText, iTextsize, "Courier New", cTxtColor);  
}


//-----------------------------------------------------------------------------
// function: GridInit()
// Description: Set the x positions for the grid colomns
//-----------------------------------------------------------------------------
int GridInit(int iCorner) {
  int iColStrLen;
  double dColStrLen;
  
  iGridColLen[0]=GRID_COL1_LEN;  
  iGridColLen[1]=GRID_COL2_LEN;    
  
  // Left side window
  if (iCorner==0 || iCorner==2) {
    dColStrLen=iGridColLen[0];
    iColStrLen = MathCeil(dColStrLen*GRID_TXT_CHR_WIDTH/GRID_BKG_BOX_WIDTH);  
    iGridColPos[0]=Dashboard_xPos;
    iGridColPos[1]=Dashboard_xPos+iColStrLen*GRID_BKG_BOX_WIDTH-1;
    iGridMktInf[0]=Dashboard_xPos+2;   // Symbol x-pos    
    iGridMktInf[2]=Dashboard_xPos+38;  // Bid x-pos
    iGridMktInf[4]=Dashboard_xPos+40;  // Ask y-pos
    iGridMktInf[5]=Dashboard_yPos+18;  // Ask y-pos
    iGridMktInf[6]=Dashboard_xPos+40;  // Spread x-pos
  }
  // Right side window
  else {
    dColStrLen=iGridColLen[1];
    iColStrLen = MathCeil(dColStrLen*GRID_TXT_CHR_WIDTH/GRID_BKG_BOX_WIDTH);  
    Comment(iColStrLen);
    iGridColPos[0]=Dashboard_xPos+iColStrLen*GRID_BKG_BOX_WIDTH-1;
    iGridColPos[1]=Dashboard_xPos;
    iGridMktInf[0]=Dashboard_xPos+78;  // Symbol x-pos
    iGridMktInf[1]=Dashboard_yPos+0;   // Symbol y-pos
    iGridMktInf[2]=Dashboard_xPos+0;   // Bid x-pos
    iGridMktInf[3]=Dashboard_yPos+3;   // Bid y-pos
    iGridMktInf[4]=Dashboard_xPos+4;   // Ask y-pos
    iGridMktInf[5]=Dashboard_yPos+18;  // Ask y-pos  
    iGridMktInf[6]=Dashboard_xPos+4;   // Spread x-pos
    iGridMktInf[7]=Dashboard_yPos+29;  // Spread y-pos
  }
  
  // Top of window
  if (iCorner==0 || iCorner==1) {
    iGridMktInf[1]=Dashboard_yPos;     // Symbol y-pos
    iGridMktInf[3]=Dashboard_yPos+3;   // Bid y-pos
    iGridMktInf[5]=Dashboard_yPos+18;  // Ask y-pos
    iGridMktInf[7]=Dashboard_yPos+29;  // Spread y-pos
  }
  // Bottom of window
  else {
    iGridMktInf[1]=CalcYPos(2)-2;   // Symbol y-pos
    iGridMktInf[3]=CalcYPos(1)-6;   // Bid y-pos
    iGridMktInf[5]=CalcYPos(2)-4;   // Ask y-pos
    iGridMktInf[7]=CalcYPos(3)-2;   // Spread y-pos
  }
  
  return(0);
} // end funcion()


//-----------------------------------------------------------------------------
// function: GridDeInit()
// Description: Erase objects created by the grid
//-----------------------------------------------------------------------------
int GridDeInit(string sObjId) {
  // Clear text objects
  for(int i=ObjectsTotal()-1; i>-1; i--)
   if (StringFind(ObjectName(i),sObjId)>=0)  ObjectDelete(ObjectName(i));
   
  return(0);
} // end funcion()


//-----------------------------------------------------------------------------
// function: DashboardBoxHeight()
// Description: Calculate the height of the dashboard box
//-----------------------------------------------------------------------------
int GridHeight() {
  int iSize=0;
  
  // Market Info
  if (Market_ShowData==true) {    
    if (Market_ShowSpread==true && Market_ShowAsk==true)
      iSize=iSize+4;
    else if (Market_ShowSpread==false && Market_ShowAsk==true)
      iSize=iSize+3;
    else if (Market_ShowSpread==true && Market_ShowAsk==false)
      iSize=iSize+3;  
    else
      iSize=iSize+2;
  }  

  // Pip data
  if (Pips_ShowData==true && iMA1Period>0 && iMA2Period>0)
      iSize=iSize+4; 
  else if (Pips_ShowData==true && (iMA1Period>0 || iMA2Period>0))
      iSize=iSize+3;
  else if (Pips_ShowData==true)
      iSize=iSize+2;
  
    // Basic Fractal
  if (FractalB_ShowData==true)
      iSize=iSize+4; 

  // Extended Fractal
  if (FractalE_ShowData==true)
      iSize=iSize+2; 

  // H1 & H4 high and low data
  if (H1HighLow_ShowData==true && H4HighLow_ShowData==true && Period()<TF_H1)
    iSize=iSize+5;
  else if (H1HighLow_ShowData==true && H4HighLow_ShowData==true && Period()<TF_H4)    
    iSize=iSize+3;
  else if (H1HighLow_ShowData==true && H4HighLow_ShowData==false)    
    iSize=iSize+3;
  else if (H1HighLow_ShowData==false && H4HighLow_ShowData==true)    
    iSize=iSize+3;
  
  // ADR data
  if (Adr_ShowData==true)
    iSize=iSize+4;
  
  if (iSize>4)
    iSize=iSize+1;

  return(iSize);
} // end funcion()


//-----------------------------------------------------------------------------
// function: GridBlankRow()
// Description: Draw a blank row with or without a line divider 
//-----------------------------------------------------------------------------
int GridBlankRow(bool bLineDiv=true) {
  int i;
  int iY;
  string sLine="";
  
  // Draw grid row
  GridWriteCell("        ", iGridCurRow, 1, GRID_PAD_OFF, " ",  CLR_NONE, Dashboard_BkgColor); 
  GridWriteCell("       ", iGridCurRow, 2, GRID_PAD_RIGHT, " ",  CLR_NONE, Dashboard_BkgColor);
  
  // Draw line divider
  if (bLineDiv) {
      // Calc y-pos from row value
    iY=CalcYPos(iGridCurRow);
    for (i=0;i<=GRID_COL1_LEN+GRID_COL2_LEN;i++) sLine=sLine+"";
    WriteText(sLine, Dashboard_xPos+2, iY, " "+iGridCurRow,  GRID_TXT_CHR_SIZE, Dashboard_DividerColor);
  }
  return(0);
}


//-----------------------------------------------------------------------------
// function: CalcYPos()
// Description: Calculate the y-coordinates from the row number
//-----------------------------------------------------------------------------
int CalcYPos(int iRow) {
  int iY;
    if (Dashboard_Corner==0 || Dashboard_Corner==1)
      iY=Dashboard_yPos+(GRID_BKG_BOX_WIDTH)*(iRow-1); 
    else
      iY= Dashboard_yPos+  ((iGridMaxRows-1)*GRID_BKG_BOX_WIDTH)- (GRID_BKG_BOX_WIDTH)*(iRow);      
  return(iY);
}




 